image AutoDOD(
image In=0,
int applyTransform=1,
int trackAlpha=1,
int trackLuminance=1,
int useRed=1,
int useGreen=1,
int useBlue=1,
float assessThreshold=0,
float proxyLevel=0.25,
int graceSize=((ceil(1/proxyLevel))*2),
const char * frames="0-1",
int pixHeight=In.height,
int pixWidth=In.width
)

{
// Set the DOD to the results of the analysis
SetDOD1 = SetDOD(In, PixelAnalyzer1.area1MinBlue*10000-graceSize, (PixelAnalyzer1.area1MaxRed*10000+graceSize)+(width-graceSize)*(1-ceil(PixelAnalyzer1.area1MaxRed)), PixelAnalyzer1.area1MinAlpha*10000-graceSize, (PixelAnalyzer1.area1MaxGreen*10000+graceSize)+(height-graceSize)*(1-ceil(PixelAnalyzer1.area1MaxRed)));

//Create a proxy version for faster processing
ProxyZoom = Zoom(In, proxyLevel, proxyLevel, "impulse", 0);

//Create an image of pixels maximizing all channels selected for use
Null = Reorder(ProxyZoom, "nnnn");
imageAlpha = Reorder(ProxyZoom, "annn");
imageBlue = Reorder(ProxyZoom, "bnnn");
imageGreen = Reorder(ProxyZoom, "gnnn");
imageRed = Reorder(ProxyZoom, "rnnn");
RedMax = Max(Null, imageRed, 1, 100*trackLuminance*useRed);
GreenMax = Max(RedMax, imageGreen, 1, 100*trackLuminance*useGreen);
BlueMax = Max(GreenMax, imageBlue, 1, 100*trackLuminance*useBlue);
AlphaMax = Max(BlueMax, imageAlpha, 1, 100*trackAlpha);


// Set to 16 bits ready to store the pixel width and height
// in the pixel data
PreppedImage = Bytes(AlphaMax, 2);

// Store max vals in r & g, min vals in b & a
// (below-threshold values are set to zero or one to prevent
// them from being detected as max or min values, respectively).
StoreVals = ColorX(PreppedImage, r>assessThreshold?(x-.5)/10000/proxyLevel:0, r>assessThreshold?(y-.5)/10000/proxyLevel:0, r>assessThreshold?(((x-.5)/proxyLevel-proxyLevel)/10000):width/10000/proxyLevel, r>assessThreshold?(((y-.5)/proxyLevel-proxyLevel)/10000):height/10000/proxyLevel);


PixelAnalyzer1 = PixelAnalyzer(StoreVals, frames, 1, "area1", 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pixWidth*proxyLevel/2, pixHeight*proxyLevel/2, pixWidth*proxyLevel, pixHeight*proxyLevel, 
    2-applyTransform);

// Choose between analyze mode and DOD mode
Select1 = Select(applyTransform, PixelAnalyzer1, SetDOD1, 
        0);


return Select1;
}