//DeSpill
//v1.1
//Oct 3, 2003
//Peter Warner

image DeSpill(
image Input=0,
float hue=.333,
float sat=1,
float val=1,
float hueRange=0,
float hueDropoff=.1,
float satRange=0,
float satDropoff=.9,
float redReplace=.5,
float greenReplace=.5,
float blueReplace=.5,
)
{
Bytes1 = Bytes(Input, 1);
Saturation1 = Saturation(Input, 0);
LookupTint = Lookup(Saturation1,
 	JSplineV(x,1,0@0,redReplace@.5,1@1), 
	JSplineV(x,1,0@0,greenReplace@.5,1@1), 
    	JSplineV(x,1,0@0,blueReplace@.5,1@1), 
	x);

SpillSuppress1 = SpillSuppress(Input, 1, 1, 1, hue-.3>.3?0:1);
ColorSpace1 = ColorSpace(Bytes1, "rgb", "hsv", 0.3, 0.59, 0.11);
ReorderHue = Reorder(ColorSpace1, "rrra");
ReorderSat = Reorder(ColorSpace1, "gggg");
LookupHSVHue = LookupHSV(ReorderHue, x,x,
      HermiteV(x,1,
		[0,0,0]@(hue-hueRange-hueDropoff),
		[1,0,0]@(hue-hueRange),
		[1,0,0]@(hue+hueRange),
		[0,0,0]@(hue+hueRange+hueDropoff)), 
	x);
LookupHSVSat = Lookup(ReorderSat, x, x, x,  HermiteV(x,1,			
		[0,0,0]@(sat-satRange-satDropoff),
		[1,0,0]@(sat-satRange),
		[1,0,0]@(sat+satRange),
		[0,0,0]@(sat+satRange+satDropoff)) 
	);
Inside1 = Inside(LookupHSVHue, LookupHSVSat, 1);
KeyMix1 = KeyMix(Input, SpillSuppress1, Inside1, 1, "R", 100, 
    0);
SwitchMatte1 = SwitchMatte(LookupTint, Inside1, 1, "R", 1, 0);
Under1 = Under(KeyMix1, SwitchMatte1, 1, 0, 0);
return Under1;
}

