image Flock(
const char * imageName="C:/images/macros/flock/bird/bird_sm.1-13@.iff", 
int clipLength=13,
int nbCopies=10,
float outputWidth=GetDefaultWidth(),
float outputHeight=GetDefaultHeight(), 
float scaleLo=.8,
float scaleHi=scaleLo+.4,
float freqX=.05, 
float freqY=4.5,
float vibrationX=.01,
float vibrationY=.04,
float vibFreqX=1,
float vibFreqY=50,
float left=outputWidth/4, 
float bottom=outputHeight/4, 
float right=outputWidth*.75, 
float top=outputHeight*.75
)

{
bg = Black(outputWidth, outputHeight,1);
Result = bg;
	
curve float flockWidth = right-left;
curve float flockHeight = top-bottom;
curve float flockHalfX = flockWidth/2;
curve float flockHalfY = flockHeight/2;
curve float flockCenterX = flockHalfX +left;
curve float flockCenterY = flockHalfY +bottom;

for (int i=1;i<nbCopies;++i){

	ClipIn = FileIn(imageName,"auto");
	CropMe = Viewport(ClipIn,0,0,outputWidth,outputHeight);

	curve float clipCenterX = ClipIn.width/2;
	curve float clipCenterY = ClipIn.height/2;

	rndvalX = rnd(i);
	rndvalY = rnd(i*5);

	// This determines the scaling randomess
	scale = rndvalX*(scaleHi-scaleLo)+scaleLo;

	// This determines the random wavering of the birds	
	
	offsetX = noise2d(time*clamp(rndvalX,.01,freqX)/10,i*3.0)-.5;
	offsetY = noise2d(time*clamp(rndvalY,.01,freqY)/10,i*4.0)-.5;
	waverX = flockCenterX+flockWidth*offsetX;
	waverY = flockCenterY+flockHeight*offsetY;

	//This randomizes the timing of the flock clip

	timeoffset = rndvalX *clipLength;
 	image TimeMe = TimeX(CropMe , floor(timeoffset+time) % clipLength+ 1);

	// This applies a rhythmic vibration to the flock

	vibX = cosd(time*vibFreqX+i*100)*flockHalfX*vibrationX;
	vibY = cosd(time*vibFreqY+i*100)*flockHalfY*vibrationY;

	//This does the actual placement of each flock member

	image MoveMe = Move2D(TimeMe, 
   		-clipCenterX + waverX + vibX, 
   		-clipCenterY + waverY + vibY, 
  		0,1, 
		scale, xScale,
		0,0,clipCenterX ,clipCenterY 
	);
	 
	Result = Over(MoveMe , Result);
  	}

    return Result ;
}
