image Rain(
int width=GetDefaultWidth(),
int height=GetDefaultHeight(),
int bytes=1,
float angle=70,
float density=0.054,
float noiseSoftness=11.1,
float fgLighting=1,
float fgLength=300,
float fgBri=fgLength/4,
float fgDensity=0.0001,
float midLighting=0.8,
float midLength=100,
float midBri=midLength*.65,
float midDensity=0.06,
float bgLighting=0.2,
float bgLength=41.8,
float bgBri=bgLength*.25,
float bgDensity=1,
float red=0.8146,
float green=0.7824,
float blue=1
)
{
    NoiseGen = Rand(width, height, 
        1, 1, time);
    RainGen = Rand(width, height, bytes, density, time);
    Ramp1 = Ramp(width, height, 1, 0, 0.81, 1, 1, 1, 1, 0, 0, 0, 0, 0, 
        0);
    BGRainDensity = Gamma(RainGen, bgDensity, rGamma, rGamma, 1);
    Bytes1 = Bytes(RainGen, 2);
    Gamma8 = Gamma(NoiseGen, 0.3, rGamma, rGamma, 0.3);
    MidRainDensity = Gamma(RainGen, midDensity, rGamma, rGamma, 1);
    Rotate5 = Rotate(Ramp1, -Angle.angle, 1, width/2, height/2, 0, 
        0.5, 0);
    BGLight = Gamma(Rotate5, bgLighting, rGamma, rGamma, rGamma);
    DilateErode1 = DilateErode(Gamma8, "rgba", 1, xPixels, 0, 0, 
        0);
    FGLight = Gamma(Rotate5, fgLighting, rGamma, rGamma, rGamma);
    FGRainDensity = Gamma(Bytes1, fgDensity, rGamma, rGamma, 1);
    MidLight = Gamma(Rotate5, midLighting, rGamma, rGamma, rGamma);
    Reorder6 = Reorder(MidRainDensity, "rrrr");
    Reorder7 = Reorder(BGRainDensity, "gggg");
    DilateErode2 = DilateErode(FGRainDensity, "rgba", 1, xPixels, 
        0, 1, 0);
    NoiseSoftness = Blur(DilateErode1, noiseSoftness, xPixels, 1, 
        "gauss", xFilter, "rgba");
    Rotate2 = Rotate(Reorder6, -Angle.angle, 1, width/2, height/2, 
        0, 0.5, 0);
    Rotate3 = Rotate(Reorder7, -Angle.angle, 1, width/2, height/2, 
        0, 0.5, 0);
    BGRainLength = Blur(Rotate3, bgLength, 0, 1, "gauss", xFilter, 
        "rgba");
    MidRainLength = Blur(Rotate2, midLength, 0, 1, "gauss", xFilter, 
        "rgba");
  //  RainGrainPan = Pan(NoiseSoftness, width*-.15, height*-.5, 0, 
   //     0.5, 0);
     RainGrainPan = Rotate(NoiseSoftness, -Angle.angle, 1, width/2, height/2, 
        0, 0.5, 0);
   Reorder5 = Reorder(DilateErode2, "bbbb");
    Rotate1 = Rotate(Reorder5, -Angle.angle, 1, width/2, height/2, 
        0, 0.5, 0);
    FGRainLength = Blur(Rotate1, fgLength, 0, 1, "gauss", xFilter, 
        "rgba");
    Reorder2 = Reorder(RainGrainPan , "rgbr");
    Reorder3 = Reorder(RainGrainPan , "rgbg");
    Reorder4 = Reorder(RainGrainPan , "rgbb");
    Outside1 = Outside(FGRainLength, Reorder2, 0);
    Outside2 = Outside(MidRainLength, Reorder3, 0);
    Outside3 = Outside(BGRainLength, Reorder4, 0);
    BGRainBri = Brightness(Outside3, bgBri);
    FGRainBri = Brightness(Outside1, fgBri);
    MidRainBri = Brightness(Outside2, midBri);
    BGRainColor = Mult(BGRainBri, red, green, blue, 1, 1);
    Bytes2 = Bytes(FGRainBri, 1);
	Inside1 = Inside(Bytes2,FGLight,1);
    Inside2 = Inside(MidRainBri, MidLight, 1);
    Inside3 = Inside(BGRainColor, BGLight, 1);
    IAdd1 = IAdd(Inside2, Inside3, 1, 100);
    IAdd2 = IAdd(Inside1 , IAdd1, 1, 100);
    Angle = Rotate(IAdd2, angle, 1, width/2, height/2, 0, 0.5, 0);
    Reorder1 = Reorder(Angle, "rgbr");
    
    return Reorder1;
}

