image Wedge(
	image In=0,
	float redCenter=0, 
	float greenCenter=0, 
	float blueCenter=0,
	float blackCenter=95,
	float whiteCenter=685,
	float colorStep=22,
	float brightnessStep=45,
	int brightnessParameter = 1,
	float lowestContrast=.9,
	float contrastCenter=.5,
	float redText=1,
	float greenText=1,
	float blueText=1
)
{

DL = DelogC(In, 
		Linear(5,
		redCenter-colorStep@1,redCenter-colorStep@9, 
		redCenter@10, redCenter@18,
		redCenter+colorStep@19,redCenter+colorStep@27,
		redCenter@28,redCenter@47,
		0@48),
		Linear(5,
		greenCenter-colorStep@1,greenCenter-colorStep@3,
		greenCenter@4,greenCenter@6,
		greenCenter+colorStep@7,greenCenter+colorStep@9,
		greenCenter-colorStep@10,greenCenter-colorStep@12,
		greenCenter@13,greenCenter@15,
		greenCenter+colorStep@16,greenCenter+colorStep@18,
		greenCenter-colorStep@19,greenCenter-colorStep@21,
		greenCenter@22,greenCenter@24,
		greenCenter+colorStep@25,greenCenter+colorStep@27,
		greenCenter@28,greenCenter@47,
		0@48),
		Linear(5,
		blueCenter-colorStep@1,blueCenter+colorStep@3,
		blueCenter-colorStep@4,blueCenter+colorStep@6,
		blueCenter-colorStep@7,blueCenter+colorStep@9,
		blueCenter-colorStep@10,blueCenter+colorStep@12,
		blueCenter-colorStep@13,blueCenter+colorStep@15,
		blueCenter-colorStep@16,blueCenter+colorStep@18,
		blueCenter-colorStep@19,blueCenter+colorStep@21,
		blueCenter-colorStep@22,blueCenter+colorStep@24,
		blueCenter-colorStep@25,blueCenter+colorStep@27,
		blueCenter@28,blueCenter@47,
		0@48),
		brightnessParameter==1?blackCenter:Linear(5,
		blackCenter@27,
		blackCenter-(2*brightnessStep)@28,blackCenter-(2*brightnessStep)@31,
		blackCenter-brightnessStep@32,blackCenter-brightnessStep@35,
		blackCenter@36,blackCenter@39,
		blackCenter+brightnessStep@40,blackCenter+brightnessStep@43,
		blackCenter+(2*brightnessStep)@44,blackCenter+(2*brightnessStep)@47,
		95@48),
		brightnessParameter==0?whiteCenter:Linear(5,
		whiteCenter@27,
		whiteCenter-(2*brightnessStep)@28,whiteCenter-(2*brightnessStep)@31,
		whiteCenter-brightnessStep@32,whiteCenter-brightnessStep@35,
		whiteCenter@36,whiteCenter@39,
		whiteCenter+brightnessStep@40,whiteCenter+brightnessStep@43,
		whiteCenter+(2*brightnessStep)@44,whiteCenter+(2*brightnessStep)@47,
		685@48),
		0.6, 1, 0
);
	Con = ContrastRGB(DL, 
		Linear(5,
		1@27,
		lowestContrast@28,
		lowestContrast+.3f@31,
		lowestContrast@32,
		lowestContrast+.3f@35,
		lowestContrast@36,
		lowestContrast+.3f@39,
		lowestContrast@40,
		lowestContrast+.3f@43,
		lowestContrast@44,
		lowestContrast+.3f@47,
		1@48),
		rValue, rValue,rValue,
		contrastCenter, 
		rCenter, rCenter, rCenter,
		0,
		rSoftClip,rSoftClip,rSoftClip
	);
	LogC4 = LogC(Con, 0, 0, 0, 95, 685, 0.6, 1, 0);
	AddText1 = AddText(LogC4, 
		"Red = {DL.rOffset}\nGreen = {DL.gOffset}\nBlue = {DL.bOffset}", "Courier Bold", 
		 width/25, xFontScale, 0.9, 20, height-20, 0, 1, 3, redText, greenText, blueText, 1, 0, 0, 0, 45);
	AddText2 = AddText(AddText1, 
		"Black = {DL.black}\nWhite = {DL.white}\nContrast = {Con.rValue}\nContrast Center = {Con.rCenter}", "Courier Bold", 
		 width/25, xFontScale, 0.9, width-20, height-20, 0, 3, 3, redText, greenText, blueText, 1, 0, 0, 0, 45);
	AddText3 = AddText(AddText2, "Frame = %f", "Courier Bold", AddText1.xFontScale, xFontScale, 1, 20, 20, 0, 1, 1, AddText1.red, AddText1.green, AddText1.blue, 1, 0, 0, 0, 45);
	return AddText(AddText3, "%D %m/%d", "Courier Bold", AddText1.xFontScale, xFontScale, 1, width-20, 20, 0, 3, 1, AddText1.red, AddText1.green, AddText1.blue, 1, 0, 0, 0, 45);
	
}


